// Generated by CoffeeScript 1.4.0
(function() {
  var slice, _;

  module.exports = _ = require('underscore');

  slice = Array.prototype.slice;

  _.mixin({
    /*
      Similar to extend, but only includes the properties that are listed in filter (filter).
      You can add an arbitrary number of objects as arguments.
      Tickets: CLOUD-65
    */

    extendFiltered: function(target, filter) {
      _.each(slice.call(arguments, 2), function(source) {
        var prop, _results;
        _results = [];
        for (prop in source) {
          if (source[prop] !== void 0 && _.include(filter, prop)) {
            _results.push(target[prop] = source[prop]);
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      });
      return target;
    },
    arrayify: function(obj) {
      if (!obj) {
        return [];
      }
      if (_.isArray(obj)) {
        return _.uniq(obj);
      }
      return [obj];
    },
    /*
      Checks if target exists, raises and error if not.
    */

    ensurePresent: function(target, targetName) {
      if (!target) {
        throw new Error("" + targetName + " is a required parameter");
      }
    }
  });

}).call(this);
